import { camelize } from 'camelize-object-key';
import { Meta, Canvas, Story, ArgsTable } from '@storybook/addon-docs/blocks';
import { linkTo } from '@storybook/addon-links';
import { defaultLayout } from '../.storybook/decorators';
import BlockVideoCarousel from './block-video-carousel';
import store from '@/.storybook/store';
import { addControls, initJsonKnobs } from '@/.storybook/helpers';

export const argTypes = {};

export const controls = {
	color: [],
	number: [],
	json: ['items'],
};

<Meta
	title="Video Carousel"
	decorators={[defaultLayout]}
	component={BlockVideoCarousel}
	argTypes={addControls(argTypes, controls)}
/>

# Video Carousel

Currently this module is used for filter landing page.

This carousel is used for videos. Each slides have title and video. The slides comes advance as each video ends. Clicking on the carousel tabs will stop the current video and advance to the selected slide and start the video for that slide.

export const Template = (args, { argTypes }) => {
	initJsonKnobs(args, argTypes, controls.json);
	return {
		props: Object.keys(argTypes),
		components: { BlockVideoCarousel },
		template: '<block-video-carousel v-bind="$props" />',
		store,
	};
};

export const items = [
	{
		copyColor: null,
		copyColorDesktop: null,
		ctaCopy: 'Learn More',
		ctaLink: { url: 'https://molekule.com/add-to-cart?skus=MinimoB_US' },
		description: null,
		heading: 'Clean air is just a few steps away',
		headingColor: '#ffffff',
		headingColorDesktop: '#ffffff',
		headingDesktop: 'Clean air is just a few steps away',
		headingDesktopAnimated: null,
		headingFadeOutDelay: 3000,
		headingFadeOutEnabled: true,
		id: null,
		imageBackground: {},
		playerParameters: null,
		slideTitle: 'Air',
		videoAspectRatioDesktop: null,
		videoAspectRatioMobile: 0.8,
		videoBackground: {
			kind: 'document',
			name: 'Air Filter Change_Desktop.mp4',
			url:
				'https://molekule.cdn.prismic.io/molekule/48b87e5a-b653-4b4e-b1dc-7fd9cb826820_Air+Filter+Change_Desktop.mp4',
		},
		videoBackgroundMobile: {
			kind: 'document',
			name: 'Air Filter Change_Desktop.mp4',
			url:
				'https://molekule.cdn.prismic.io/molekule/48b87e5a-b653-4b4e-b1dc-7fd9cb826820_Air+Filter+Change_Desktop.mp4',
		},
	},
	{
		copyColor: null,
		copyColorDesktop: null,
		ctaCopy: 'Learn More',
		ctaLink: { url: 'https://molekule.com/add-to-cart?skus=MinimoB_US' },
		description: null,
		heading: null,
		headingColor: null,
		headingColorDesktop: null,
		headingDesktop: null,
		headingDesktopAnimated: null,
		headingFadeOutDelay: null,
		headingFadeOutEnabled: false,
		id: null,
		imageBackground: {},
		playerParameters: null,
		slideTitle: 'Air Mini',
		videoAspectRatioDesktop: null,
		videoAspectRatioMobile: 0.8,
		videoBackground: {
			kind: 'document',
			name: 'Air Mini Mo Landing Page_Looping Banner_V4_720p_Web.mp4',
			url:
				'https://molekule.cdn.prismic.io/molekule%2F26fed3c4-b28e-4946-9f2a-0e5d703f5208_mini+mo+landing+page_looping+banner_v4_720p_web.mp4',
		},
		videoBackgroundMobile: {
			kind: 'document',
			name: 'Mini Mo Landing Page_Looping Banner_V4_720p_Web.mp4',
			url:
				'https://molekule.cdn.prismic.io/molekule%2F26fed3c4-b28e-4946-9f2a-0e5d703f5208_mini+mo+landing+page_looping+banner_v4_720p_web.mp4',
		},
	},
	{
		copyColor: null,
		copyColorDesktop: null,
		ctaCopy: 'Learn More',
		ctaLink: { url: 'https://molekule.com/add-to-cart?skus=MinimoB_US' },
		description: null,
		heading: null,
		headingColor: null,
		headingColorDesktop: null,
		headingDesktop: null,
		headingDesktopAnimated: null,
		headingFadeOutDelay: null,
		headingFadeOutEnabled: false,
		id: null,
		imageBackground: {},
		playerParameters: null,
		slideTitle: 'Air Pro',
		videoAspectRatioDesktop: null,
		videoAspectRatioMobile: 0.8,
		videoBackground: {
			kind: 'document',
			name: 'Air Pro B2B Landing Page Video_V2.mp4',
			url:
				'https://molekule.cdn.prismic.io/molekule/03239089-68ad-44c2-b882-bc7195c8ee25_Air+Pro+B2B+Landing+Page+Video_V2.mp4',
		},
		videoBackgroundMobile: {
			kind: 'document',
			name: 'Air Pro B2B Landing Page Video_V2.mp4',
			url:
				'https://molekule.cdn.prismic.io/molekule/03239089-68ad-44c2-b882-bc7195c8ee25_Air+Pro+B2B+Landing+Page+Video_V2.mp4',
		},
	},
];

<Canvas withSource="none">
	<Story
		name="default"
		args={{
			initialSlide: 0,
			items: camelize(items),
		}}
	>
		{Template.bind({})}
	</Story>
</Canvas>

## Vue Component Props

<ArgsTable of={BlockVideoCarousel} />
